ref_barren=barren;

grads2=((s(index(:,2)*2-1) - s(index(:,1)*2-1))./Le).^2;
diffbar=grads2.*Iintegral(:).*thickbar.^5.*((rho*g)^3)/2*E;


%%**************
%%For run with one type of bed...
diffbar(:)=diffbar(:)+C_sliding.*rho.*g.*(thickbar.^2).*meltedbar; % basal sliding
%%
%%
%%For run w/ variable type of bed...
%%%%Sliding dependent everywhere on T
%diffbar(:)=diffbar(:)...
%   + C_sliding1.*((Xcontr(1)<=Xposition(1:nel) & Xposition(1:nel)<Xcontr(2)) | (Xcontr(3)<=Xposition(1:nel) & Xposition(1:nel)<Xcontr(4))) ...
%    .*rho.*g.*(thickbar.^2).*meltedbar ...
%   + C_sliding2.*((Xposition(1:nel)<Xcontr(1)) | (Xcontr(2)<=Xposition(1:nel) & Xposition(1:nel)<Xcontr(3)) | (Xcontr(4)<=Xposition(1:nel))) ...
%    .*rho.*g.*(thickbar.^2).*meltedbar; % basalsliding
%

%%%%Region 1 has T dependence with C1 rate,
%%%%then Region 2 independent of T at C2 and finally
%%%%Region 3 independent of T at C3 rate...
% diffbar(:)=diffbar(:)...
%    + C_sliding1.*(Xposition(1:nel)<=Xcontr(1))...
%    .*rho.*g.*(thickbar.^2).*meltedbar ...
%    + C_sliding2.*((Xposition(1:nel)<=Xcontr(2)) & (Xcontr(1)<Xposition(1:nel)))...
%    .*rho.*g.*(thickbar.^2) ...
%    + C_sliding3.*(Xcontr(2)<Xposition(1:nel)).*rho.*g.*(thickbar.^2); % basalsliding
% 
% 
%*************
%% ... done calculating velocity information we needed


%Ice thickness and slope boundary conditions assigned here:
thick_spec=zeros(nods*2,1);
%thick_spec(2)=-b(2);   %used when specifying a zero-slope divide 
%thick_spec(nods*2-1)=50; % If we wanted to specify thickness as nonzero at downstream end



thick_spec=thick_spec.*(~ms);

nactive=sum(ms);	
PDI=sparse([1:nactive]',find(ms==1)',ones(nactive,1),nactive,nods*2);

sold=s;

A=sparse(rowperm,colperm,spdiags(expand_by_4*diffbar,0,nel*4,nel*4)*Bgauss,nods*2,nods*2);
Aprime=PDI*(Aperm/dtmass+A)*PDI';

%%For use when keeping track of floating ice...
%R=Aperm*(thick/dtmass+Adot-Bdot) - A*bi;

%For use without floating ice runs...
R=Aperm*(thick/dtmass+Adot-Bdot) - A*b;
Rprime=PDI*(R-(Aperm/dtmass+A)*thick_spec); %For divides (fixed zero slope) and non-zero thickness boundary conditions (works for zero-valued cases also)
thickprime=Aprime\Rprime;
thicktentative=PDI'*thickprime + thick_spec;  % Note: look out for divides.  Putting known BCs back into soln.

clear Rprime Aprime PDI 

%Taking a timestep and checking if barren or not, then set BCs and take timestep over again
%w/ zero thickness where barren... otherwise it will allow for negative thickness and the
%associated increased slope will propagate into ice sheet...

barrenold=zeros(nods*2,1);

barren(1:2:nods*2-1)=(thicktentative(1:2:nods*2-1)<=0);
barren(4:2:nods*2-2)=( barren(1:2:nods*2-5) & barren(5:2:nods*2-1) );
barren(2)=barren(3);
barren(nods*2)=barren(nods*2-3);
barren(2:2:nods*2)=barren(2:2:nods*2).*barren(1:2:nods*2-1); %added to take care of 3-noded island of ice... 1,0  0,1  1,0 would result when want 1,0 0,0 1,0

while ( (sum(abs(barren-barrenold))~=0) & (sum(~barren)>0) ) %test when barren doesn't change anymore and avoid problems in case when all ice is gone.

nactive=sum(ms & ~barren);	%fewer active variables that are actually communicating with ice... can reduce matrix further in masbal soln b/c more knowns when no ice at node.	
PDI=sparse([1:nactive]',find(ms & (~barren))',ones(nactive,1),nactive,nods*2);
Rprime=PDI*(R-(Aperm/dtmass+A)*thick_spec); %For divides (fixed zero slope) and non-zero thickness boundary conditions 
Aprime=PDI*(Aperm/dtmass+A)*PDI';
thickprime=Aprime\Rprime; % Solve for tentative thickness (assuming hbarren is correct)
thicktentative=PDI'*thickprime + thick_spec;  % Note: look out for divides.  Putting known BCs back into soln.

clear Rprime Aprime PDI 

barrenold=barren;
barren(1:2:nods*2-1)=(thicktentative(1:2:nods*2-1)<=0);
barren(4:2:nods*2-2)=( barren(1:2:nods*2-5) & barren(5:2:nods*2-1) );
barren(2)=barren(3);
barren(nods*2)=barren(nods*2-3);
barren(2:2:nods*2)=barren(2:2:nods*2).*barren(1:2:nods*2-1); %added to take care of 3-noded island of ice... 1,0  0,1  1,0 would result when want 1,0 0,0 1,0

end
thick=thicktentative.*(~barren);
s=b+thick;

advancelogicpsu
 
clear Rprime Aprime PDI 



%The below finds where we have thin ice cover and assigns Tsurface at surface and Tpmp profile over the node(s) to keep thermal gradient reasonable...
thinice=find(thick(1:2:nods*2)<10 & thick(1:2:nods*2)>0);

if length(thinice)>0
for hh=rocklev+1:nlev-1
 	T(thinice,hh)=Tnot-rho*g*thick(thinice*2-1)*(1-zetaice(hh-rocklev))*Phi;	%assign Tpmp
end
T(thinice,nlev)=Tsurface(thinice);
end
