% time dependent variables at a particular node...

%column 1-- time(years, negative before present)=year

%column 2-- surface elevation at node 30 (m).
heightice=s(30*2-1);

%column 3-- ice thickness at node 30 (m).
thickice=thick(30*2-1);

%column 4-- basal temperature at node 30 real temperature (not corrected) (oC)
basaltemp=T(30,rocklev+1)-Tnot;

%column 5-- surface temperature at node 30 (oC)
surftemp=T(30,nlev)-Tnot;

%column 6-- accumulation rate at node 30 (m/y ice equivalent)
%NOTE: I am assuming that they mean accum rate of ice!  (Weighted Mean)

if barren(30*2-1)==1
iceacc=0;
else
iceacc=Precip(30);
end
iceacc=iceacc*seconds;

%column 7-- basal melt rate at node 30 (m/y ice equivalent)

if barren(30*2-1)==1
basalmelt=0;
else
basalmelt=Bdot(30*2-1);
end
basalmelt=basalmelt*seconds;

%column 8-- basal heat budget at node 30

if barren(30*2-1)==1
heatbal=0;
else
heatbal=heatin(30)-heatout(30);
end


nodehistory(timestep,:)=[year heightice thickice basaltemp surftemp iceacc basalmelt heatbal];

