% 15 time dependent variables... a la EISMINT

% EISMINT 11 time dependent variables, TV.  
% 15 time dependent variables... eais

%column 1-- time(years, negative before present)=year

%column 2-- ice covered surface (m^2).  Assume 1m in y-direction.

icecov=0; %area of ice cover

for n=1:nel
icecov=icecov+ ( (2-sum(barren(index(n,:)*2-1))>0) )*Le(n);
end




clear n
%column 3-- total ice volume (m^3).  Assume 1m in y-direction.  
%Vfinal from eismint_exp1deltav.m

%column 4-- mean accumulation rate over ice (m/y ice equivalent)
%NOTE: I am assuming that they mean accum rate of ice!  (Weighted Mean) 

%column 5-- mean ablation rate over ice (m/y ice equivalent)
%NOTE: I am assuming that they mean ablation rate of ice! (Weighted Mean)

if ~surfmasbal
iceacc=0;
for n=1:nel
iceacc=iceacc+ ( (2-sum(barren(index(n,:)*2-1))>0) )*Le(n)*mean(Precip(index(n,:)));
end
if(icecov>0)
iceacc=iceacc/icecov;
else
iceacc=0;
end
iceacc=iceacc*seconds;
elseif surfmasbal
iceacc=0;
iceabl=0;
for n=1:nel
iceacc=iceacc+ ( (2-sum(barren(index(n,:)*2-1))>0) )*Le(n) ...
*mean((Precip(index(n,:))-0.003*PDD(index(n,:))*1000/rho/seconds).* ...
((mean(Precip(index(n,:))-0.003*PDD(index(n,:))*1000/rho/seconds)>=0) & (snow(index(n,:)*2-1)>=firnlayer)));

iceabl=iceabl+ ( (2-sum(barren(index(n,:)*2-1))>0) )*Le(n) ...
*mean((0.008*PDD(index(n,:))*1000/rho/seconds).*( (snow(index(n,:)*2-1)==0) & (soup(index(n,:)*2-1)==0) ));
%*mean(-(0.008*PDD(index(n,:))*1000/rho/seconds).*( (snow(index(n,:)*2-1)==0) & (soup(index(n,:)*2-1)==0) ));
end
if(icecov>0)
iceacc=iceacc/icecov;
iceabl=iceabl/icecov;
else
iceacc=0;
iceabl=0;
end

iceacc=iceacc*seconds;
iceabl=iceabl*seconds;
end

clear n

%column 5-- calving (m^3/y ice equivalent). Assume 1m in y-direction.
%Arbitrarily, taking flux past nodes near margin with bed at SL (due to their SL proximity) for this quantity. 
%Ice shelves would be necessary in order to obtain more accurate quantity.


calving=0;
westnode=find(abs(b(1:2:westsea*2)-sealev)==min(abs(b(1:2:westsea*2)-sealev)));
%eastnode=nods-westsea+find(abs(b(2*(nods-eastsea)-1:2:nods*2)-sealev)==min(abs(b(2*(nods-eastsea)-1:2:nods*2)-sealev)));
eastnode=eastsea+find(abs(b(2*(eastsea)-1:2:nods*2)-sealev)==min(abs(b(2*(eastsea)-1:2:nods*2)-sealev)));
eastcalving=0;
westcalving=0;

for n=2:icelev
eastcalving=eastcalving+(udefnode(eastnode,n-1)+udefnode(eastnode,n))/2*dznode(eastnode,n-1);
westcalving=westcalving-(udefnode(westnode,n-1)+udefnode(westnode,n))/2*dznode(westnode,n-1);
end

calving=(eastcalving+westcalving)*seconds;

clear n


%column 6-- maximum surface elevation (m).

highestice=max(s(1:2:nods*2-1));

%column 7-- I position of the highest node.

Iposition_highestice=find(s(1:2:nods*2-1)==max(s(1:2:nods*2-1)));

%column 8-- Potential Energy in the Ice Sheet, [N m]
PE=0;
PE=sum(0.5*rho*g.*thickbar(:).*(sbar(:) + bbar(:)).*Le(:));
%

history(timestep,:)=[year icecov Vfinal iceacc calving highestice Iposition_highestice PE];





if ((year==500 & ~greenhouse) & dt_years>10)
save modelclimate.mat history
end
if (year==500 & greenhouse) 
save modelwarming.mat history
end
if ((year==500 & ~greenhouse) & dt_years==10)
save modelclimate10.mat history
end

