% The vertical heat conduction time step:  This version is used with
% explicit thermal advection.

for n=1:icelev  
W_strainheatnode(:,n)=2*(rho*g)^4*E.*Anode(:,n).*s(2:2:nods*2).^4.*(thick(1:2:(nods*2-1))* ...
     (1-zetaice(n))).^4;

Qnode(:,n)=W_strainheatnode(:,n) ...
   - advection*( rho*ciceconstant*(u_total(:,n).*( (sign(u_total(:,n))==1).*(UPWINDddx_p*T(:,rocklev+n)) ...
   + (sign(u_total(:,n))==-1).*(UPWINDddx_m*T(:,rocklev+n)) )) );
end


% Computation of the "D-term"

dudzeta=zeros(nods,icelev);
dudzeta(:,1)=(udefnode(:,2)-udefnode(:,1))/dzeta(1);

for n=2:icelev-1
	dudzeta(:,n)=( (udefnode(:,n+1)-udefnode(:,n))/dzeta(n)	...
				+ (udefnode(:,n)-udefnode(:,n-1))/dzeta(n-1) )/2;	
end
dudzeta(:,icelev)=(udefnode(:,icelev)-udefnode(:,icelev-1))/dzeta(icelev-1);

% Computation of ice divergence at each level, at each node:
for n=1:icelev
divnode(:,n)=FEMify(2:2:nods*2,:)*udefnode(:,n) + dudzeta(:,n).* ...
(zetaice(n)*s(2:2:nods*2) + (1-zetaice(n))*b(2:2:nods*2))./(thick(1:2:nods*2)+barren(1:2:nods*2));
end 

basalmeltingpsu

Intdivnode=zeros(nods,icelev);
Dtermnode=zeros(nods,icelev);
Vertvelnode=zeros(nods,icelev);


for n=2:icelev
Intdivnode(:,n)=Intdivnode(:,n-1)+(divnode(:,n-1)+divnode(:,n))/2*(zetaice(n)-zetaice(n-1));

Vertvelnode(:,n)=Vertvelnode(:,n-1)-(divnode(:,n-1)+divnode(:,n))/2.*dznode(:,n-1) ...
  - FEMify(2:2:nods*2,:)*uslidenode.*dznode(:,n-1) + u_total(:,1).*b(2:2:nods*2) - Bdot(1:2:nods*2);  % this is the vertical velocity relative to the bed
												
end



for n=2:icelev
Dtermnode(:,n)=thick(1:2:nods*2-1).*( zetaice(n).*Intdivnode(:,icelev) - Intdivnode(:,n) ); 
end

for n=1:icelev
w(:,n)= ( (Dtermnode(:,n) - zetaice(n)*Adot(1:2:2*nods) - (1-zetaice(n))*Bdot(1:2:2*nods)) )...
+(udefnode(:,n)-udefnode(:,1)).*(zetaice(n)-1).*b(2:2:nods*2) ...
+(udefnode(:,icelev)-udefnode(:,n)).*zetaice(n).*s(2:2:nods*2);
end
w=[zeros(nods,rocklev) w]';

qbar=zeros(nvel,nods);

for n=rocklev+1:nlev-1
   qbar(n,:)=(Qnode(:,n-rocklev)'+ Qnode(:,n+1-rocklev)')/2;
   wbar(n,:)=(w(n,:) + w(n+1,:))/2;
end


Peclet_num=thick(1:2:nods*2)'.*max(abs(wbar))/kiceconstant*ciceconstant*rho;

polythermal=zeros(icelev,nods);
specified_T=zeros(nlev,nods);
Tvalues_specified=zeros(nlev,nods);
specified_T(nlev,:)=(~barren(1:2:nods*2))'.*(   ((Peclet_num')<100) )' ...
   + (barren(1:2:nods*2))';

for n=rocklev+1:nlev-1
specified_T(n,:)=(barren(1:2:nods*2))';
 end

%specified_T(rocklev+1,:)=melted'.*(~barren(1:2:nods*2))' ;
% %%%WAIS...
% heatbudgetpsu04  %determine how far down glacier meltwater will raise T(b)-->Tpmp
% specified_T(rocklev+1,:)=(melted'.*(~barren(1:2:nods*2))' | (heatbudget'.*(~barren(1:2:nods*2))') ) ;
%%%thawed forever from Xcontr(1)--->
specified_T(rocklev+1,:)=( melted'.*(~barren(1:2:nods*2))' | (Xcontr(1)<Xposition(:))' )  ;

if length(thinice)>0
    specified_T(rocklev+1:nlev,thinice)=1;
end


Tvalues_specified(nlev,:)=Tsurface(:)';

for n=rocklev+1:nlev-1
Tvalues_specified(n,:)=(~barren(1:2:nods*2))'.*(Tnot-rho*g*thick(1:2:nods*2)'*(1-zetaice(n-rocklev))*Phi) ...
 +(barren(1:2:nods*2))'.*Tsurface(:)';
 end

nactive=sum(~specified_T(:));
PDI=sparse([1:nactive]',find(~specified_T(:))',ones(nactive,1),nactive,nlev*nods);


	denom1=thick(1:2:nods*2)+barren(1:2:nods*2);
	denom2=(thick(1:2:nods*2)+barren(1:2:nods*2)).^2;
	
	
value=zeros(nvel,nods*4);

if checkrock
for n=1:rocklev
value(n,1:nods)=(valuevertperm1(n,1) + ...
    valuevertperm3(n,1))./denom1'  ;

value(n,nods+1:2*nods)=(valuevertperm1(n,2) + ...
    valuevertperm3(n,2))./denom1' ;

value(n,2*nods+1:3*nods)=(valuevertperm1(n,3) + ...
    valuevertperm3(n,3))./denom1'  ;

value(n,3*nods+1:4*nods)=(valuevertperm1(n,4) + ...
    valuevertperm3(n,4))./denom1'  ;
end
end
for n=rocklev+1:nvel
value(n,1:nods)=valuevertperm1(n,1) + ...
  (w(n,1:nods).*valuevertperm21(n,1) ...
	+ w(n+1,1:nods).*valuevertperm22(n,1)) ...
                    ./denom1(1:nods)' ...
  +  valuevertperm3(n,1)./denom2(1:nods)'  ;

value(n,nods+1:2*nods)=valuevertperm1(n,2) + ...
  (w(n,1:nods).*valuevertperm21(n,2) ...
	+ w(n+1,1:nods).*valuevertperm22(n,2)) ...
                    ./denom1(1:nods)' ...
  +  valuevertperm3(n,2)./denom2(1:nods)'  ;

value(n,2*nods+1:3*nods)=valuevertperm1(n,3) + ...
  (w(n,1:nods).*valuevertperm21(n,3) ...
	+ w(n+1,1:nods).*valuevertperm22(n,3)) ...
                    ./denom1(1:nods)' ...
  +  valuevertperm3(n,3)./denom2(1:nods)'  ;

value(n,3*nods+1:4*nods)=valuevertperm1(n,4) + ...
  (w(n,1:nods).*valuevertperm21(n,4) ...
	+ w(n+1,1:nods).*valuevertperm22(n,4)) ...
                    ./denom1(1:nods)' ...
  +  valuevertperm3(n,4)./denom2(1:nods)'  ;
end

w=w';
w=w(:,rocklev+1:nlev);



A=sparse(rowvertperm(:),colvertperm(:),value(:),nods*nlev,nods*nlev);

Aprime=PDI*A*PDI';

if checkrock
for n=1:rocklev
value(n,1:nods)=valuevertperm1(n,1).*T(:,lindex(n,1))'./denom1' ;  
 
value(n,nods+1:2*nods)=valuevertperm1(n,2).*T(:,lindex(n,2))'./denom1' ;  

value(n,2*nods+1:3*nods)=valuevertperm1(n,3).*T(:,lindex(n,1))'./denom1' ;  

value(n,3*nods+1:4*nods)=valuevertperm1(n,4).*T(:,lindex(n,2))'./denom1' ;  
end
end

for n=rocklev+1:nvel
value(n,1:nods)=valuevertperm1(n,1).*T(:,lindex(n,1))' + ...
 dl(n)*qbar(n,:)/2 ;  
 
value(n,nods+1:2*nods)=valuevertperm1(n,2).*T(:,lindex(n,2))' ;  

value(n,2*nods+1:3*nods)=valuevertperm1(n,3).*T(:,lindex(n,1))' ;  

value(n,3*nods+1:4*nods)=valuevertperm1(n,4).*T(:,lindex(n,2))'  + ...
 dl(n)*qbar(n,:)/2 ;  
end

R=sparse(rowvertperm(:),ones(nods*nvel*4,1),value(:),nods*nlev,1);

R(Alocation)=R(Alocation)+Geoflux./denom1; % deep rock boundary flux

Rprime=PDI*(R-A*(Tvalues_specified(:).*(specified_T(:))));

%new faster version which prevents reordering of tridiagonal matrix
spparms('autommd',0);
T_tentativeprime=Aprime\Rprime;
spparms('autommd',1);
T_tentative(:)=PDI'*T_tentativeprime+Tvalues_specified(:).*(specified_T(:));
  
specified_Told=specified_T;

clear Rprime Aprime PDI 

%If melted, not trying to change to frozen here... that is saved for basalmeltingpsu.
%If frozen, then can change to melted here if T>=Tpmp...

melted= ( melted  | (T_tentative(rocklev+1,:)'>=((Tnot-rho*g*thick(1:2:nods*2)*Phi)+melttolerance)) );
%specified_T(rocklev+1,:)=( ( melted' & (~barren(1:2:nods*2))' ) | (barren(1:2:nods*2)' ) );
% %%WAIS...
% specified_T(rocklev+1,:)=( ( melted' & (~barren(1:2:nods*2))' ) | (barren(1:2:nods*2)' ) ...
% 							| (heatbudget'.*(~barren(1:2:nods*2))') );
%%%WAIS... thawed forever from Xcontr(1)--->
specified_T(rocklev+1,:)=( ( ( melted' & (~barren(1:2:nods*2))' ) | (barren(1:2:nods*2)' ) ) ...
							| (Xcontr(1)<Xposition(:))' )  ;



for n=rocklev+2:nlev-1
polythermal(n-rocklev,:)=(T_tentative(n,:)>=(Tnot-rho*g*thick(1:2:nods*2)'*(1-zetaice(n-rocklev))*Phi));
specified_T(n,:)=(( polythermal(n-rocklev,:)&(~barren(1:2:nods*2)') ) | (barren(1:2:nods*2))' );
end

if length(thinice)>0
specified_T(rocklev+1:nlev,thinice)=1;
end

if ( (sum(abs(specified_T(:)-specified_Told(:)))~=0) )
	
nactive=sum(~specified_T(:));
PDI=sparse([1:nactive]',find(~specified_T(:))',ones(nactive,1),nactive,nlev*nods);

if checkrock
for n=1:rocklev
value(n,1:nods)=valuevertperm1(n,1).*T(:,lindex(n,1))'./denom1';  
value(n,nods+1:2*nods)=valuevertperm1(n,2).*T(:,lindex(n,2))'./denom1';  
value(n,2*nods+1:3*nods)=valuevertperm1(n,3).*T(:,lindex(n,1))'./denom1';  
value(n,3*nods+1:4*nods)=valuevertperm1(n,4).*T(:,lindex(n,2))'./denom1';  
end
end
for n=rocklev+1:nvel
value(n,1:nods)=valuevertperm1(n,1).*T(:,lindex(n,1))' + ...
 dl(n)*qbar(n,:)/2 ;  
value(n,nods+1:2*nods)=valuevertperm1(n,2).*T(:,lindex(n,2))' ;  
value(n,2*nods+1:3*nods)=valuevertperm1(n,3).*T(:,lindex(n,1))' ;  
value(n,3*nods+1:4*nods)=valuevertperm1(n,4).*T(:,lindex(n,2))'  + ...
 dl(n)*qbar(n,:)/2 ;  
end
R=sparse(rowvertperm(:),ones(nods*nvel*4,1),value(:),nods*nlev,1);

R(Alocation)=R(Alocation)+Geoflux./denom1; % deep rock boundary flux

Rprime=PDI*(R-A*(Tvalues_specified(:).*(specified_T(:))));
				
Aprime=PDI*A*PDI';
%new faster version which prevents reordering of tridiagonal matrix
spparms('autommd',0);	
T_tentativeprime=Aprime\Rprime;
spparms('autommd',1);
T_tentative(:)=PDI'*T_tentativeprime+Tvalues_specified(:).*(specified_T(:));
clear Rprime Aprime PDI 

end





T=T_tentative';

	
basalmeltingpsu  %This is added here to update Bdot for new melted, heatin, and heatout
				   %This Bdot is not utilized by model, just for graphics, unless another loop is made...
				   %in which case, basalmeltingpsu is included in massstep anyway.
